php.net |  support |  documentation |  report a bug |  advanced search |  search howto |  statistics |  random bug |  login
Bug #42339 using --without-apxs2 results in an error/abort; configuring the release build
Submitted: 2007-08-18 17:36 UTC Modified: 2007-09-03 12:14 UTC
From: codeslinger at compsalot dot com Assigned:
Status: Closed Package: Apache2 related
PHP Version: 5.2.3 OS: SimplyMEPIS Linux 6.5
Private report: No CVE-ID: None
View Add Comment Developer Edit
Welcome! If you don't have a Git account, you can't do anything here.
You can add a comment by following this link or if you reported this bug, you can edit this bug over here.
(description)
Block user comment
Status: Assign to:
Package:
Bug Type:
Summary:
From: codeslinger at compsalot dot com
New email:
PHP Version: OS:

 

 [2007-08-18 17:36 UTC] codeslinger at compsalot dot com
Description:
------------
There are many options for PHP, such as ncurses, which are not compatible with phpN-mod.so  

But when trying to build a CLI only config, it fails with an error message that APXS is not enabled.



Reproduce code:
---------------
I tried many variants, here is the simplest:

'./configure'    --enable-cli    --disable-cgi     --without-apxs2  --without-apxs


Expected result:
----------------
Expected: No errors


Note:  the following command *does* work

'./configure'    --enable-cli    --disable-cgi    '--with-apxs2=/usr/bin/apxs2'  


Actual result:
--------------
Configuring SAPI modules
checking for AOLserver support... no
checking for Apache 1.x module support via DSO through APXS...

Sorry, I was not able to successfully run APXS.  Possible reasons:

1.  Perl is not installed;
2.  Apache was not compiled with DSO support (--enable-module=so);
3.  'apxs' is not in your path.  Try to use --with-apxs=/path/to/apxs
The output of /usr/local/src/php-5.2.3/no follows
./configure: line 4396: /usr/local/src/php-5.2.3/no: No such file or directory
configure: error: Aborting



Patches

Add a Patch

Pull Requests

Add a Pull Request

History

AllCommentsChangesGit/SVN commitsRelated reports
 [2007-08-18 17:46 UTC] codeslinger at compsalot dot com
this is actually a documentation problem.

the correct command should be

'./configure'    --enable-cli     --disable-cgi   --disable-apxs
 [2007-08-20 07:48 UTC] jani@php.net
This is  not true. Simply doing './configure --disable-cgi' gives you CLI. There isn't such option as '--disable-apxs'..
You propably used unclean sources.
 [2007-08-22 19:13 UTC] codeslinger at compsalot dot com
The sources used are fine, I downloaded them direct from php.net and verified the md5.

The documentation on the options is incomplete.

I tried --without-apxs because even though it is not documented, it is symmetrical to the option --with-apxs  which is documented, but that did not work.  Also, not saying anything about apxs at all did not work either.  Everything I tried, the ./configure failed.  

After entering this bug and thinking about it some more, it occurred to me to try  --disable-apxs   and did discover that it was the only thing which produced the desired behavior of a CLI only build.  And that's when I changed the category to a documentation bug.  Anything else results in the error: "Sorry, I was not able to successfully run APXS."  I get that error even though I have not specified --with-apxs. 

php by default is trying to build the apxs version even when it is not requested.

I note in the change log that there have been some recent changes to the "make".  perhaps this problem is newly introduced.

Also my actual goal was to build both CGI and CLI at the same time, but for the purpose of this bug I decided to simplify and isolate as much as possible.
 [2007-08-23 09:19 UTC] jani@php.net
# ./configure --disable-cgi 
or
# ./configure --without-apxs2

Both work just fine here. You're simply doing something wrong or I'm high on crack. :)

I even removed Apache from my test machine to be sure.
Any other SAPIs aren't enabled by default except for CLI and CGI.
With plain ./configure without any options you get both.

Please it with this latest snapshot instead of 5.2.3:
http://snaps.php.net/php5.2-latest.tar.gz

 [2007-08-26 08:18 UTC] codeslinger at compsalot dot com
Hi Jani, Thank you for looking at this, I appreciate your efforts.

Using the snap from  2007-08-26 at 04:30   
I can not reproduce the problem.   Therefore the problem has been fixed in cvs and that's why you aren't seeing it.

However, in the release version of php 5.2.3  using the following command continues to result in the error message and abort as described.

./configure --without-apxs2  

What appears to be happening is that "without" is being mistaken for a "with" request.  And since the default path does not match the actual path it aborts with a not found error.

The reason I was specifying "--without-apxs2"  is because I wanted to make certain that apxs would not be built and clobber my previous apxs which has different/incompatible configure options.  My assumption was that because the cgi gets built even when it is not requested, that the apxs was also probably being built.  Now that I understand better how to interpret the many thousands of lines of output...   I see that apxs is not being built unless specifically requested.  I do not recall seeing this fact (that cgi gets built and apxs does not, by default) anywhere in the documentation.
 [2007-08-26 22:37 UTC] jani@php.net
Fixed -> closed. And never was really a bug since you're not supposed to  use --without-apxs2 and only SAPIs enabled by default are CLI/CGI since forever including 5.2.3.
 
PHP Copyright © 2001-2022 The PHP Group
All rights reserved.
Last updated: Wed Aug 17 16:05:45 2022 UTC